#!/usr/bin/perl
#-----------------------------------------------
# Claudio e Massimo
# Script per tracciare le connessioni TCP/UDP e inviare le info al syslog
#
#-----------------------------------------------

my $rec, $key, $Istat, $IstatC, $IstatL;

my $CTFile = '/var/log/conntrack.log';

my $Facility = 'local6.info';
my $Tag      = 'CONNTRACK';

my $cmd = '/usr/local/sbin/conntrack -L';
my $logcmd = '/bin/logger -p ' . $Facility . ' -t ' . $Tag ;


while ( 1 ) {

    my %hash = (); 

    $Istat = open ( CT , $CTFile );

    if ( $Istat ) {
	
	while ( $rec = <CT> ) {
	    #print $rec;
	    ( $key = $rec ) =~ s/^(\S+).*(src=.*\s+)packets=.*\s+(src=.*)\s+packets=.*$/$1$2$3/g;
	    $key =~ s/\s+//g;
	    #print $key . "\n";
	    $hash{$key} = $rec;
	}
	close ( CT );
    }
    
    
    $IstatL = open ( LOG , '|' . $logcmd );
    $IstatC = open ( CT , '>' . $CTFile );
    $Istat = open ( OUT, $cmd . ' 2>/dev/null |' );
    
    if ( $Istat && $IstatC && $IstatL ) {
	
	while ( $rec = <OUT> ) {
	    next if ( $rec =~ /^conntrack/ );
	    print CT $rec;
	    ( $key = $rec ) =~ s/^(\S+).*(src=.*\s+)packets=.*\s+(src=.*)\s+packets=.*$/$1$2$3/g;
	    $key =~ s/\s+//g;
	    #print $key . "\n";
	    next if ( defined ( $hash{$key} ) );
	    #print $Tag . ": " . $rec;
	    print LOG $rec;
	}
	close ( OUT );
	close ( CT );
	close ( LOG );
    }
    sleep 10;
}
